/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */

package org.diacalc.mobile;

import com.sun.lwuit.*;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.layouts.BorderLayout;
import com.sun.lwuit.layouts.GridLayout;
import com.sun.lwuit.plaf.UIManager;
import com.sun.lwuit.util.Resources;
import java.io.*;
import java.util.*;
import javax.microedition.io.PushRegistry;
import javax.microedition.media.Manager;
import javax.microedition.media.MediaException;
import javax.microedition.media.Player;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import org.diacalc.mobile.components.BackForm;
import org.diacalc.mobile.components.RotationListener;
import org.diacalc.mobile.maths.*;
import org.diacalc.mobile.products.ProductGroup;
import org.diacalc.mobile.products.ProductInBase;
import org.diacalc.mobile.products.ProductInMenu;
import org.diacalc.mobile.products.ProductW;
/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */

public class DCJmobile extends javax.microedition.midlet.MIDlet implements ActionListener {
    public static final int PROGRAM_VERSION = 12;
    public static final int PRODUCTS = 0;
    public static final int MENU = 1;
    public static final int DIARY = 2;
    public static final int COEFS = 3;
    public static final int SETTINGS = 4;
    
    private static final int EXIT_COMMAND = 1;
    private static final int BACK_COMMAND = 2;
    private static final int ABOUT_COMMAND = 3;
    

    private static final Command exitCommand = new Command("Выход", EXIT_COMMAND);
    private static final Command backCommand = new Command("Назад", BACK_COMMAND){
                            public void actionPerformed(ActionEvent evt) {
                                mainScreen.show();
                            }
                        };
    private static final Command aboutCommand = new Command("О программе", ABOUT_COMMAND);
    
    
    private FormBase[] PANE = new FormBase[5];

    private static BackForm mainScreen;
    
    private Hashtable demosHash = new Hashtable();
    private ButtonActionListener bAListner = new ButtonActionListener();

    private FormBase currentPane;
    
    public final static String DCJ_RMS = "DCJmobile";

    private RecordStore  rs = null;
    
    private User user;
    private Vector menu = new Vector();
    private Vector groups = new Vector();
    private Vector prods = new Vector();

    private Vector diary = new Vector();
    private Vector diaryRecs = new Vector();

    private Vector coefUnits = new Vector();

    private boolean shouldSaveBase = false;
    private boolean shouldSaveDiary = false;
    private boolean shouldSaveCoefUnits = false;
    private boolean refreshProdsForm = false;
    private boolean refreshMenuForm = false;
    private boolean refreshDiaryForm = false;

    private Timer timer = null;
    private Label lblTimer;
    private SecondsTicker sec_ticker;
    private Timer ticker;
    private Player p = null;
    private long starttime;

    public static final String[][] RUSSIAN_SM_QWERTY_T9 = new String[][]{
        {"й", "ц", "у", "к", "е", "н", "г", "ш", "щ", "з","х"},
        {"ф", "ы", "в", "а", "п", "р", "о", "л", "д","ж","э"},
        {"я", "ч", "с", "м", "и", "т", "ь","б","ю","ъ"},
        {"$Mode$", "$T9$", "$Space$", "$Delete$", "$OK$"}
    };
    public static final String[][] RUSSIAN_BIG_QWERTY_T9 = new String[][]{
        {"Й", "Ц", "У", "К", "Е", "Н", "Г", "Ш", "Щ", "З","Х"},
        {"Ф", "Ы", "В", "А", "П", "Р", "О", "Л", "Д","Ж","Э"},
        {"Я", "Ч", "С", "М", "И", "Т", "Ь","Б","Ю","Ъ"},
        {"$Mode$", "$T9$", "$Space$", "$Delete$", "$OK$"}
    };
    public static final String[][] RUSSIAN_SM_QWERTY = new String[][]{
        {"й", "ц", "у", "к", "е", "н", "г", "ш", "щ", "з","х"},
        {"ф", "ы", "в", "а", "п", "р", "о", "л", "д","ж","э"},
        {"я", "ч", "с", "м", "и", "т", "ь","б","ю","ъ"},
        {"$Mode$", "$Space$", "$Delete$", "$OK$"}
    };
    public static final String[][] RUSSIAN_BIG_QWERTY = new String[][]{
        {"Й", "Ц", "У", "К", "Е", "Н", "Г", "Ш", "Щ", "З","Х"},
        {"Ф", "Ы", "В", "А", "П", "Р", "О", "Л", "Д","Ж","Э"},
        {"Я", "Ч", "С", "М", "И", "Т", "Ь","Б","Ю","Ъ"},
        {"$Mode$", "$Space$", "$Delete$", "$OK$"}
    };
    public static VirtualKeyboard createRusTxtKeyboard(final boolean _T9){
        VirtualKeyboard vk = new VirtualKeyboard(){
            private final boolean useT9 = _T9;
            private boolean flagExit = true;
            public void setInputType(int inputType) {} //bug fix
            public void dispose(){//Любое закрытие клавиатуры сымитирует нажатие Ок
                if (useT9){
                    super.dispose();
                }
                else{
                    if (flagExit){
                        flagExit = false;
                        this.actionCommand(new Command("Ok",VirtualKeyboard.OK));
                        flagExit = true;
                    }else{
                        super.dispose();
                    }
                }
            }
        };
        if (_T9){ 
            vk.addInputMode("абв", DCJmobile.RUSSIAN_SM_QWERTY_T9 );
            vk.addInputMode("АБВ", DCJmobile.RUSSIAN_BIG_QWERTY_T9 );
            vk.setInputModeOrder(new String[]{"абв","АБВ",
            VirtualKeyboard.QWERTY_MODE,
            VirtualKeyboard.NUMBERS_SYMBOLS_MODE});
        }
        else{
            vk.addInputMode("абв", DCJmobile.RUSSIAN_SM_QWERTY );
            vk.addInputMode("АБВ", DCJmobile.RUSSIAN_BIG_QWERTY );
            vk.setInputModeOrder(new String[]{"абв","АБВ",
            VirtualKeyboard.QWERTY_MODE,
            VirtualKeyboard.NUMBERS_SYMBOLS_MODE});
        }
        
        return vk;
    }
    /*public static String[][] NUMBERS_KEYS = new String[][]
                {{"1", "2", "3","+","-"},
                {"4", "5", "6", "*", "/"},
                {"7", "8", "9","(",")"},
                {"0",".","$Delete$","$OK$"}};*/
    
    /*public static VirtualKeyboard createNumbersKeyboard(){
        VirtualKeyboard vk = new VirtualKeyboard(){
            private Vector closeListeners = new Vector();
            public void addCloseListener(CloseListener cl){
                closeListeners.addElement(cl);
            }
            public void removeCloseListener(CloseListener cl){
                closeListeners.removeElement(cl);
            }
            private void fireCloseEvent(){
                for(int i=0;i<closeListeners.size();i++){
                    ((CloseListener)closeListeners.elementAt(i)).wasClosed();
                }
            }
            private boolean flagExit = true;
            public void setInputType(int inputType) {} //bug fix
            public void dispose(){//Любое закрытие клавиатуры сымитирует нажатие Ок
                if (flagExit){
                    flagExit = false;
                    this.actionCommand(new Command("Ok",VirtualKeyboard.OK));
                    flagExit = true;
                }else{
                    fireCloseEvent();
                    super.dispose();
                }
            }
        };
        
        vk.addInputMode("1+2", DCJmobile.NUMBERS_KEYS );
        vk.setInputModeOrder(new String[]{"1+2"});
        
        return vk;
    }*/
    public Vector getCoefs(){
        return coefUnits;
    }
    public Vector getDiary(){
        return diary;
    }
    public Vector getDiaryRecs(){
        return diaryRecs;
    }
    public void setDiary(Vector v){
        diary = v;
        shouldSaveDiary = true;
    }
    public void setDairyRecs(Vector v){
        diaryRecs = v;
        shouldSaveDiary = true;
    }
    public User getUser(){
        return user;
    }
    public void setUser(User u){
        user = u;
    }
    public void setMenu(Vector v){
        refreshMenuForm = true;
        menu = v;
    }
    public Vector getMenu(){
        return menu;
    }
    public Vector getGroups(){
        return groups;
    }
    public Vector getProds(){
        return prods;
    }

    public void setNeedSaveBase(){
        shouldSaveBase = true;
    }
    public void setNeedSaveDiary(){
        shouldSaveDiary = true;
    }
    public void setNeedSaveCoefs(){
        shouldSaveCoefUnits = true;
    }
    
    public void startApp() {
        try {
            Display.init(this);
            if (!Display.getInstance().isTouchScreenDevice()){
                Dialog.show("Ошибка", "Программа расчитана на использование устройства с touch screen'ом\n"
                        + "Для вашего устройства используйте версию 1.7", "OK", null);
                notifyDestroyed();
            }
            
            initSavedDatas();
            
            starttime = System.currentTimeMillis();
            if (user.getTimerTime()==0 || (starttime-user.getTimerTime())>(1000*60*3)){
                user.setS1(user.getTargetSugar());
                user.setS2(user.getTargetSugar());
            }

            PANE = new FormBase[]{
                    new ProdsForm(),new MenuForm(),new DiaryForm(), new CoefsForm(),
                    /*new InternetForm(),*/new SettingsForm()
            };
            
            //set the theme
            //Resources theme = Resources.open("/DCJtheme_mobile.res");
            Resources theme = Resources.open("/theme.res");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
            UIManager.getInstance().getLookAndFeel().setTactileTouchDuration(10);//Вибрируем при нажатии на кнопки
            Dialog.setCommandsAsButtons(true);
            
            
            
            
            makeText();

            Display.getInstance().callSerially(new Runnable() {
                public void run() {
                    setMainForm();
                }
            });

        } catch (Throwable ex) {
            //ex.printStackTrace();
            Dialog.show("Exception", ex.getMessage(), "OK", null);
        }

    }

    private  Vector menuFromByteArray( byte[] data )
                                 throws IOException {
        ByteArrayInputStream bin =
                 new ByteArrayInputStream( data );
        DataInputStream din = new DataInputStream( bin );

        int count = din.readInt();
        Vector v = new Vector( count );

        while( count-- > 0 ){
            v.addElement( new ProductInMenu(
                    din.readUTF(),//name
                    din.readFloat(),//prot
                    din.readFloat(),//fat
                    din.readFloat(),//carb
                    din.readInt(),//gi
                    din.readFloat(),
                    -1) );//saved
        }

        din.close();

        return v;
    }
    private Vector groupsFromByteArray( byte[] data )
                                 throws IOException {
        ByteArrayInputStream bin =
                 new ByteArrayInputStream( data );
        DataInputStream din = new DataInputStream( bin );

        int count = din.readInt();
        Vector v = new Vector( count );

        while( count-- > 0 ){
            v.addElement( new ProductGroup(
                    din.readUTF(),//name
                    din.readInt()) );//id
        }

        din.close();

        return v;
    }
    private Vector coefUnFromByteArray( byte[] data )
                                     throws IOException {
        ByteArrayInputStream bin =
                new ByteArrayInputStream( data );
        DataInputStream din = new DataInputStream( bin );

        int count = din.readInt();
        Vector v = new Vector( count );

        while( count-- > 0 ){
            v.addElement( new CoefUnit(
                    din.readInt(),//time
                    new Factors(
                        din.readFloat(),//k1
                        din.readFloat(),//k2
                        din.readFloat(),//k3
                        user.getFactors().getBEValue()//be - это берем из данных пользователя
                        )//прямые коэф-ты
                     ));
        }
        din.close();

        return v;
    }
    private Vector diaryFromByteArray( byte[] data )
            throws IOException {
        ByteArrayInputStream bin =
                 new ByteArrayInputStream( data );
        DataInputStream din = new DataInputStream( bin );

        int count = din.readInt();
        Vector v = new Vector( count );

        while( count-- > 0 ){
            int type = din.readInt();//Определяем тип события
            if (type==DiaryUnit.SUGAR){
                v.addElement(new DiaryUnit(
                        din.readInt(),//id
                        din.readLong(),//time
                        din.readUTF(),//comment
                        din.readFloat()//sugar
                        ));
            }else if (type==DiaryUnit.MENU){
                v.addElement(new DiaryUnit(
                        din.readInt(),//id
                        din.readLong(),//time
                        din.readUTF(),//comment
                        din.readFloat(),//sh1
                        din.readFloat(),//sh2
                        new Factors(
                            din.readFloat(),//k1
                            din.readFloat(),//k2
                            din.readFloat(),//k3
                            din.readFloat(),//be
                            Factors.DIRECT),//прямые коэф-ты
                        din.readFloat(),//dose
                        new ProductW(
                            din.readUTF(),//name
                            din.readFloat(),//prot
                            din.readFloat(),//fat
                            din.readFloat(),//carb
                            din.readInt(),//gi
                            din.readFloat())//weight
                        ));
            }else if (type==DiaryUnit.COMMENT){
                v.addElement(new DiaryUnit(
                        din.readInt(),//id
                        din.readLong(),//time
                        din.readUTF()//comment
                        ));
            }
        }
        din.close();

        return v;
    }
    private Vector diaryRecsFromByteArray( byte[] data )
            throws IOException {
        ByteArrayInputStream bin =
                 new ByteArrayInputStream( data );
        DataInputStream din = new DataInputStream( bin );

        int count = din.readInt();
        Vector v = new Vector( count );

        while( count-- > 0 ){
            ProductInMenu pr =  new ProductInMenu(
                    din.readUTF(),
                    din.readFloat(),
                    din.readFloat(),
                    din.readFloat(),
                    din.readInt(),
                    din.readFloat(),//weight
                    -1);
            pr.setOwner(din.readInt());
            v.addElement( pr );
        }

        din.close();
        return v;
    }
    private Vector productsFromByteArray( byte[] data )
                                 throws IOException {
        ByteArrayInputStream bin =
                 new ByteArrayInputStream( data );
        DataInputStream din = new DataInputStream( bin );

        int count = din.readInt();
        Vector v = new Vector( count );

        while( count-- > 0 ){
            v.addElement( new ProductInBase(
                    din.readUTF(),//name
                    din.readFloat(),//prot
                    din.readFloat(),//fat
                    din.readFloat(),//carb
                    din.readInt(),//gi
                    din.readFloat(), //weight
                    din.readBoolean(),//mobile
                    din.readInt(), //owner
                    din.readInt()) );//usage
        }

        din.close();
        return v;
    }
    private byte[] diaryRecsToByteArray( Vector v )
            throws IOException {
        ByteArrayOutputStream bout =
                   new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream( bout );

        int sz = v.size();
        dout.writeInt( sz );
        Enumeration e = v.elements();
        while( e.hasMoreElements() ){
            ProductInMenu pr = (ProductInMenu)e.nextElement();
            dout.writeUTF(pr.getName());
            dout.writeFloat(pr.getProt());
            dout.writeFloat(pr.getFat());
            dout.writeFloat(pr.getCarb());
            dout.writeInt(pr.getGi());
            dout.writeFloat(pr.getWeight());
            dout.writeInt(pr.getOwner());
        }
        dout.close();
        return bout.toByteArray();
    }
    private byte[] diaryToByteArray( Vector v )
            throws IOException {
        ByteArrayOutputStream bout =
                   new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream( bout );

        int sz = v.size();
        dout.writeInt( sz );
        Enumeration e = v.elements();
        while( e.hasMoreElements() ){
            DiaryUnit du = (DiaryUnit)e.nextElement();
            dout.writeInt(du.getType());
            if (du.getType()==DiaryUnit.SUGAR){
                dout.writeInt(du.getId());
                dout.writeLong(du.getTime());
                dout.writeUTF(du.getComment());
                dout.writeFloat(du.getSh1());
            }else if (du.getType()==DiaryUnit.MENU){
                dout.writeInt(du.getId());
                dout.writeLong(du.getTime());
                dout.writeUTF(du.getComment());
                dout.writeFloat(du.getSh1());
                dout.writeFloat(du.getSh2());
                    dout.writeFloat(user.getFactors().getK1(Factors.DIRECT));
                    dout.writeFloat(user.getFactors().getK2());
                    dout.writeFloat(user.getFactors().getK3());
                    dout.writeFloat(user.getFactors().getBE(Factors.DIRECT));
                dout.writeFloat(du.getDose());
                    dout.writeUTF(du.getProduct().getName());
                    dout.writeFloat(du.getProduct().getProt());
                    dout.writeFloat(du.getProduct().getFat());
                    dout.writeFloat(du.getProduct().getCarb());
                    dout.writeInt(du.getProduct().getGi());
                    dout.writeFloat(du.getProduct().getWeight());
            }
            else if(du.getType() == DiaryUnit.COMMENT){
                dout.writeInt(du.getId());
                dout.writeLong(du.getTime());
                dout.writeUTF(du.getComment());
            }
        }

        dout.close();
        return bout.toByteArray();
    }
    private  byte[] menuToByteArray( Vector v )
                               throws IOException {
        ByteArrayOutputStream bout =
                   new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream( bout );

        int sz = v.size();
        dout.writeInt( sz );

        Enumeration e = v.elements();
        while( e.hasMoreElements() ){
            ProductInMenu prod = (ProductInMenu)e.nextElement();
            dout.writeUTF(prod.getName());
            dout.writeFloat(prod.getProt());
            dout.writeFloat(prod.getFat());
            dout.writeFloat(prod.getCarb());
            dout.writeInt(prod.getGi());
            dout.writeFloat(prod.getWeight());
        }

        dout.close();

        return bout.toByteArray();
    }
    private byte[] groupsToByteArray( Vector v )
                               throws IOException {
        ByteArrayOutputStream bout =
                   new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream( bout );

        int sz = v.size();
        dout.writeInt( sz );

        Enumeration e = v.elements();
        while( e.hasMoreElements() ){
            ProductGroup gr = (ProductGroup)e.nextElement();
            dout.writeUTF(gr.getName());
            dout.writeInt(gr.getId());
        }
        dout.close();
        return bout.toByteArray();
    }
    private byte[] coefUnToByteArray( Vector v )
                               throws IOException {
        ByteArrayOutputStream bout =
                   new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream( bout );

        int sz = v.size();
        dout.writeInt( sz );

        Enumeration e = v.elements();
        while( e.hasMoreElements() ){
            CoefUnit un = (CoefUnit)e.nextElement();
            dout.writeInt(un.getTime());
                dout.writeFloat(un.getFactors().getK1Value());
                dout.writeFloat(un.getFactors().getK2());
                dout.writeFloat(un.getFactors().getK3());
        }
        dout.close();
        return bout.toByteArray();
    }
    private byte[] prodsToByteArray( Vector v )
                               throws IOException {
        ByteArrayOutputStream bout =
                   new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream( bout );

        int sz = v.size();
        dout.writeInt( sz );

        Enumeration e = v.elements();
        while( e.hasMoreElements() ){
            ProductInBase prod = (ProductInBase)e.nextElement();
            dout.writeUTF(prod.getName());
            dout.writeFloat(prod.getProt());
            dout.writeFloat(prod.getFat());
            dout.writeFloat(prod.getCarb());
            dout.writeInt(prod.getGi());
            dout.writeFloat(prod.getWeight());
            dout.writeBoolean(prod.isMobile());
            dout.writeInt(prod.getOwner());
            dout.writeInt(prod.getUsage());
        }

        dout.close();

        return bout.toByteArray();
    }

    private void saveDatas(boolean isProds,boolean isDiary,boolean isCoefs){
        try{
            rs = RecordStore.openRecordStore( DCJ_RMS, true );
            ByteArrayOutputStream bout = new ByteArrayOutputStream();
            DataOutputStream dout = new DataOutputStream( bout );

            dout.writeUTF(user.getLogin());
            dout.writeUTF(user.getPass());
            dout.writeUTF(user.getServer());
            dout.writeFloat(user.getFactors().getK1(Factors.DIRECT));
            dout.writeFloat(user.getFactors().getK2());
            dout.writeFloat(user.getFactors().getK3());
            dout.writeFloat(user.getFactors().getBE(Factors.DIRECT));
            dout.writeInt(user.getRound());
            dout.writeInt(user.getInfo());
            dout.writeBoolean(user.isBackGrSupported());
            dout.writeLong(user.getTimerTime());
            dout.writeUTF(user.getMessage());
            dout.writeBoolean(user.isPlasma());
            dout.writeBoolean(user.isMmol());
            dout.writeFloat(user.getS1());
            dout.writeFloat(user.getS2());
            dout.writeBoolean(user.isTimeSense());
            dout.writeFloat(user.getTargetSugar());
            dout.writeFloat(user.getLowSugar());
            dout.writeFloat(user.getHiSugar());
            dout.writeInt(user.getTimeCorr());
            dout.writeInt(user.getTimeDiary());

            dout.close();
            byte[] data = bout.toByteArray();
            if (rs.getNumRecords()==0){
                rs.addRecord(data, 0, data.length);
            }else{
                rs.setRecord(1, data, 0, data.length );
            }
            data = menuToByteArray(menu);
            if (rs.getNumRecords()>1){
                rs.setRecord(2, data, 0, data.length );
            }else{
                rs.addRecord(data, 0, data.length);
            }//Пользователь - 1 Меню - 2
            if (isProds || (rs.getNumRecords()>=2 && (isDiary || isCoefs))){
                //Сохраняем если нужно сохранить продукты
                //или если кол-во записей 2 и нужно слить дневник или коэффициенты
                data = groupsToByteArray(groups);
                if (rs.getNumRecords()>2){
                    rs.setRecord(3, data, 0, data.length );
                }else{
                    rs.addRecord(data, 0, data.length);
                }
                data = prodsToByteArray(prods);
                if (rs.getNumRecords()>3){
                    rs.setRecord(4, data, 0, data.length );
                }else{
                    rs.addRecord(data, 0, data.length);
                }
            }//Пользователь - 1 Меню - 2 Группы - 3 Продукты - 4
            if (isDiary || (rs.getNumRecords()>=4 && isCoefs)){
                //Сохраняем если нужно сохранить дневник
                //или если кол-во записей 4 и нужно слить коэффициенты
                data = diaryToByteArray(diary);
                if (rs.getNumRecords()>4){
                    rs.setRecord(5, data, 0, data.length );
                }
                else{
                    rs.addRecord(data, 0, data.length);
                }
                data = diaryRecsToByteArray(diaryRecs);
                if (rs.getNumRecords()>5){
                    rs.setRecord(6, data, 0, data.length );
                }
                else{
                    rs.addRecord(data, 0, data.length);
                }
            }
            //Пользователь - 1 Меню - 2 Группы - 3 Продукты - 4
            //Записи дневника - 5 Детали дневника - 6
            if (rs.getNumRecords()>=6 && isCoefs){
                data = coefUnToByteArray(coefUnits);
                if (rs.getNumRecords()>6){
                    rs.setRecord(7, data, 0, data.length );
                }
                else{
                    rs.addRecord(data, 0, data.length);
                }
            }
            //Пользователь - 1 Меню - 2 Группы - 3 Продукты - 4
            //Записи дневника - 5 Детали дневника - 6 Коэффициенты - 7

        } catch( RecordStoreException e ){
        } catch( IOException e ){
            // handle IO error here
            //e.printStackTrace();
        } finally {
            try {
                rs.closeRecordStore();
            } catch( RecordStoreException e ){
            // Ignore this exception
            }
        }
    }
    private void initSavedDatas(){
        boolean createprods = true;
        try{
            rs = RecordStore.openRecordStore( DCJ_RMS, true );
            int rds = rs.getNumRecords();
            if (rds>0){//Есть записи о пользователе
                ByteArrayInputStream bin;
                DataInputStream din;

                byte[] data = rs.getRecord( 1 );
                try{
                    bin = new ByteArrayInputStream( data );
                    din = new DataInputStream( bin );

                    user = new User(din.readUTF(),
                                    din.readUTF(),
                                    din.readUTF(),
                                    new Factors(
                                        din.readFloat(),//k1
                                        din.readFloat(),//k2
                                        din.readFloat(),//k3
                                        din.readFloat(),//be
                                        Factors.DIRECT),//прямые коэф-ты
                                    din.readInt(),//round
                                    din.readInt(),//info
                                    din.readBoolean(),//backGrSupport
                                    din.readLong(),//timerTime
                                    din.readUTF(),//message
                                    din.readBoolean(),//plasma
                                    din.readBoolean(),//mmol
                                    din.readFloat(),//sugar1
                                    din.readFloat(),//sugar2
                                    din.readBoolean(),//time sense
                                    din.readFloat(),//targetSugar
                                    din.readFloat(),//low level
                                    din.readFloat(),//hi level
                                    din.readInt(),//time correction
                                    din.readInt()//time diary export correction
                                    );
                    din.close();
                }
                catch( IOException e ){
                    user = new User("","",User.DEFAULT_SERVER_PATH,new Factors(),
                        User.ROUND_1,User.PFC_INFO,false,0,"",Sugar.WHOLE,
                        Sugar.MMOL,5.6f,5.6f,false,5.6f,3.3f,7.8f,0,0);
                }
            }
            else{
                user = new User("","",User.DEFAULT_SERVER_PATH,new Factors(),
                        User.ROUND_1,User.PFC_INFO,false,0,"",Sugar.WHOLE,
                        Sugar.MMOL,5.6f,5.6f,false,5.6f,3.3f,7.8f,0,0);
            }
            if (rds>1){//Есть записи о меню
                try{
                     menu = menuFromByteArray(rs.getRecord( 2 ));
                }
                catch(IOException ex){}
            }//А иначе ничего не делаем, т.к. по умолчанию меню пустое
            if (rds>2){//Есть группы
                try{
                     groups = groupsFromByteArray(rs.getRecord( 3 ));
                }
                catch(IOException ex){}
                if (rds>3){//Есть продукты
                    try{
                        prods = productsFromByteArray(rs.getRecord( 4 ));
                    }
                    catch(IOException ex){}
                }
                createprods = false;
            }
            if (rds>4){//есть записи в дневнике
                try{
                    diary = diaryFromByteArray(rs.getRecord(5));
                }
                catch(IOException ex){}
                if (rds>5){//Есть описания продуктов в дневнике
                    try{
                        diaryRecs = diaryRecsFromByteArray(rs.getRecord( 6 ));
                    }
                    catch(IOException ex){}
                }
            }
            if (rds>6){//Есть записи о коэф-ах
                try{
                    coefUnits = coefUnFromByteArray(rs.getRecord(7));
                }
                catch(IOException ex){}
            }
            //А иначе ничего не делаем, т.к. по умолчанию меню пустое
        } catch( RecordStoreException e ){
            //e.printStackTrace();
        } finally {
            try {
                rs.closeRecordStore();
            } catch( RecordStoreException e ){
            // Ignore this exception
            }
        }
        if (createprods){
            groups.addElement(new ProductGroup("Первая",0));
            groups.addElement(new ProductGroup("Вторая",1));
            groups.addElement(new ProductGroup("Третья",2));

            prods.addElement(new ProductInBase("Первый",1.2f,3.2f,3.5f,45,100f,false,0,0));
            prods.addElement(new ProductInBase("Второй",2.2f,3.2f,4.5f,55,100f,false,0,0));
            prods.addElement(new ProductInBase("Третий",3.2f,3.2f,5.5f,45,100f,false,0,0));

            prods.addElement(new ProductInBase("Четвертый",4.2f,3.2f,6.5f,65,100f,false,1,0));
            prods.addElement(new ProductInBase("Пятый",5.2f,3.2f,7.5f,45,100f,false,1,0));

            prods.addElement(new ProductInBase("Шестой",6.2f,3.2f,8.5f,75,100f,false,2,0));
            prods.addElement(new ProductInBase("Седьмой",7.2f,3.2f,9.5f,45,100f,false,2,0));
        }
    }
    public void shouldRefreshMenu(){
        refreshMenuForm = true;
    }
    public void shouldRefreshDiary(){
        refreshDiaryForm = true;
    }
    public void addProductToMenu(ProductInBase pr){
        boolean found = false;
        for(int i=0;i<menu.size();i++){
            if (pr.getId()==((ProductInMenu)menu.elementAt(i)).getId() ){
                found = true;
                break;
            }
        }
        if (!found){
            menu.addElement(new ProductInMenu(pr));
            refreshMenuForm = true;
        }
    }
    public void removeProductFromMenu(ProductInBase pr){
        ProductInMenu m_pr = null;
        for(int i=0;i<menu.size();i++){
            if (pr.getId()==((ProductInMenu)menu.elementAt(i)).getId() ){
                m_pr = (ProductInMenu)menu.elementAt(i);
                break;
            }
        }
        if (m_pr!=null){
            menu.removeElement(m_pr);
            refreshMenuForm = true;
        }
    }
    public void setLoadedBase(Vector groups,Vector prods){
        this.groups = groups;
        this.prods = prods;
        shouldSaveBase = true;
        refreshProdsForm = true;
        Ordering.setSortField(Ordering.NAME_FIELD);
        Ordering.sort(this.prods);
    }
    public void shouldRefreshProductsForm(){
        refreshProdsForm = true;
    }
    public void showForm(int f,boolean refresh){
        currentPane = PANE[f];
        if (f==DCJmobile.PRODUCTS){
            currentPane.run(backCommand, DCJmobile.this,refresh || refreshProdsForm);
            refreshProdsForm = false;
        }
        else if (f==DCJmobile.MENU && (refresh || refreshMenuForm) ){
            Ordering.setSortField(Ordering.NAME_FIELD);
            Ordering.setSortType(Ordering.SORT_BY_ASC);
            Ordering.sort(menu);
            currentPane.run(backCommand, DCJmobile.this,refresh || refreshMenuForm);
            refreshMenuForm = false;
        }
        else if (f==DCJmobile.DIARY && (refresh || refreshDiaryForm) ){
            //тут сортировка по дате, по целому числу
            Ordering.setSortField(Ordering.TIME_FIELD);
            Ordering.setSortType(Ordering.SORT_BY_ASC);
            Ordering.sort(diary);
            currentPane.run(backCommand, DCJmobile.this,refresh || refreshDiaryForm);
            refreshDiaryForm = false;
        }
        else currentPane.run(backCommand, DCJmobile.this,refresh);
    }
    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
        if (timer!=null && user.getTimerTime()>0 && !unconditional){
            if (Dialog.show("Вопрос", "Запущен таймер\nЧто делаем?", "Свернуть", "Закрыть")){
                if (user.isBackGrSupported()){
                    Display.getInstance().minimizeApplication();
                    return;//Ничего не делаем, т.к. свернули
                }
                else{
                    try{
                        PushRegistry.registerAlarm(getClass().getName(),
                            user.getTimerTime() );
                    }catch(Exception ex){}
                }
            }
            else{
                user.setTimerTime(0);
                user.setMessage("");

                if (!user.isBackGrSupported()){
                    try{
                        PushRegistry.registerAlarm(getClass().getName(),
                            0 );
                    }catch(Exception ex){}

                    try{
                        Thread.sleep(500);
                    }catch(Exception ex){}
                }

            }
            
        }//true && !true
        saveDatas(shouldSaveBase && !unconditional,
                shouldSaveDiary && !unconditional,
                shouldSaveCoefUnits && !unconditional);
        notifyDestroyed();
    }

    public void actionPerformed(ActionEvent evt) {
        Command cmd = evt.getCommand();
        switch (cmd.getId()) {
            case EXIT_COMMAND:
                destroyApp(false);
                break;
            case ABOUT_COMMAND:
                BackForm aboutForm = new BackForm("О программе",
                        backCommand);
                aboutForm.setScrollableY(true);
                aboutForm.setLayout(new BorderLayout());
                TextArea aboutText = new TextArea(getAboutText(), 5, 10);
                aboutText.setEditable(false);
                aboutForm.addComponent(BorderLayout.CENTER, aboutText);
                /*aboutForm.addCommand(new Command("Назад") {
                    public void actionPerformed(ActionEvent evt) {
                        mainScreen.show();
                    }
                })*/;
                
                aboutForm.show();
                break;
        }
    }
    private void setMainForm() {
        mainScreen = new BackForm("DCJmobile",exitCommand){
            public void actionPerformed(ActionEvent ae){//Этот финт нужен, что бы BackForm могла обработать события меню
                DCJmobile.this.actionPerformed(ae);
            }
        };
        
        mainScreen.addMenuCommand(aboutCommand, this);
        
        //mainScreen.setTransitionOutAnimator(CommonTransitions.createFade(200));
        //mainScreen.setTransitionInAnimator(CommonTransitions.createFade(200));

        mainScreen.setLayout(new BorderLayout());

        //Создаем квадрат 2*2
        Container pane = new Container(new GridLayout(2,2));
        int bW = 0;
        for (int i=0;i<PANE.length-1;i++){//Добавляем 4 кнопки
            Button b = createButton(PANE[i].getName(),PANE[i].getIconName(),i);
            pane.addComponent(b);
            bW = Math.max(b.getPreferredW()+10, bW);
        }
        
        Button btnSettings = createButton(PANE[PANE.length-1].getName(),PANE[PANE.length-1].getIconName(),PANE.length-1);
        
        
        mainScreen.addComponent(BorderLayout.NORTH, pane);
        mainScreen.addComponent(BorderLayout.SOUTH, btnSettings);
        
        //Calculate the number of columns for the GridLayout according to the
        //screen width
        /*int width = Display.getInstance().getDisplayWidth(); //get the display width
        int cols = 0;
        if(cols == 0){
            cols = width / bW;
        }
        int rows = PANE.length / cols;
        pane.setLayout(new GridLayout(rows, cols));*/
        
        
        //mainScreen.addCommand(exitCommand);
        //mainScreen.addCommand(aboutCommand);
        mainScreen.addRotationListener(new RotationListener() {
            public void rotationHappend() {
                shouldRefreshMenu();
            }
        });
        
        mainScreen.addCommandListener(this);
        mainScreen.show();

        if ( user.getTimerTime()>0){
            if ( (starttime-user.getTimerTime())>(1000*60*3)){//Если более 3 минут прождали
                //таймер просрочен
                java.util.Calendar c = java.util.Calendar.getInstance();
                c.setTime( new Date(user.getTimerTime()) );
                Dialog.show("Сообщение", "Есть запись о просроченном таймере\n" +
                        "Время таймера:"+
                        c.get(java.util.Calendar.HOUR_OF_DAY)+":"+
                        ( c.get(java.util.Calendar.MINUTE)<10?
                        "0"+c.get(java.util.Calendar.MINUTE):
                        ""+c.get(java.util.Calendar.MINUTE) )+
                        "\nДата:"+c.get(java.util.Calendar.DAY_OF_MONTH)+"."+
                        c.get(java.util.Calendar.MONTH)+"."+
                        c.get(java.util.Calendar.YEAR)+
                        "\nСообщение:\n"+user.getMessage(), "Ok", null);
                user.setTimerTime(0);
                user.setMessage("");
            }
            else{
                enableAlarm(false);
            }
        }else{
            if (user.isTimeSense()) calcCoefsbyTime();
        }
    }
    private Button createButton(String name,String icon,int pane){
        Image selIm = null;
        //Image unselIm = null;
        try{
            selIm = Image.createImage("/images/icons/"+icon+"_sel.png");
            //unselIm = Image.createImage("/images/icons/"+icon+"_unsel.png");
        }catch (IOException ex){}

        final Button b = new Button(name, selIm);
        //b.setRolloverIcon(selIm);
        b.addActionListener(bAListner);
        b.setTactileTouch(true);
        b.getStyle().setAlignment(Button.CENTER);
        //if (Display.getInstance().getDisplayWidth()>200) тут была проверка для мальеньких экранов
        b.setTextPosition(Button.BOTTOM);
        demosHash.put(b, new Integer(pane) );
        return b;
    }
    public void calcCoefsbyTime(){
        if (!user.isTimeSense() ||
                (coefUnits.isEmpty())) return;//нет коэф-ов, выходим
        java.util.Calendar cl = java.util.Calendar.getInstance();
        cl.set(java.util.Calendar.HOUR_OF_DAY,
                cl.get(java.util.Calendar.HOUR_OF_DAY)+user.getTimeCorr());
        if (coefUnits.size()==1){//Если есть только один коэффициент, то и вычислять нечего
            user.setFactors(
                    new Factors(
                        ((CoefUnit)coefUnits
                            .firstElement()).getFactors() ));
            return;
        }
        //Теперь получаем текущее время в секундах
        int tm = cl.get(java.util.Calendar.HOUR_OF_DAY) * 60 * 60 +
                cl.get(java.util.Calendar.MINUTE) * 60;//время в секундах
        
        CoefUnit lo = (CoefUnit)coefUnits.lastElement();
        CoefUnit hi = (CoefUnit)coefUnits.firstElement();
        //Ищем lo
        if (tm>=((CoefUnit)coefUnits.firstElement()).getTime() ){
            for(int i=0;i<coefUnits.size();i++){
                if (tm<((CoefUnit)coefUnits.elementAt(i)).getTime()  ){
                    break;
                }else{
                    lo = (CoefUnit)coefUnits.elementAt(i);
                }
            }
        }
        //Ищем hi
        if (tm<((CoefUnit)coefUnits.lastElement()).getTime() ){
            for(int i=0;i<coefUnits.size();i++){
                if ( tm<((CoefUnit)coefUnits.elementAt(i)).getTime() ){
                    hi = (CoefUnit)coefUnits.elementAt(i);
                    break;
                }
            }
        }
        //Разница во времени
        int delta = hi.getTime() - lo.getTime();
        if (delta<0) delta += 24 * 60 * 60;
        //Разница между текущим временем и минимальной отметкой
        int curr = tm  - lo.getTime();
        if (curr<0) curr += 24 * 60 * 60;
        
        float c = (float)curr / (float)delta;
        user.getFactors().setK1Value( lo.getFactors().getK1Value() +
                c * (hi.getFactors().getK1Value()-lo.getFactors().getK1Value())  );
        user.getFactors().setK2( lo.getFactors().getK2() +
                c * (hi.getFactors().getK2()-lo.getFactors().getK2()));
        user.getFactors().setK3( lo.getFactors().getK3() +
                c * (hi.getFactors().getK3()-lo.getFactors().getK3()));

    }
    private String getAboutText() {
        return "Данная программа предназначена для подсчета доз инсулина при сахарном диабете.\n" +
                "Автор программы: Топоров Константин (Connie)\n" +
                "Программа распространяется под лицензией GPL v3.0\n" +
                "Сайт программы http://diacalc.org\n"
                + "Справка к программе http://diacalc.org/help";
    }

    private class ButtonActionListener implements ActionListener {
        public void actionPerformed(ActionEvent evt) {
            showForm(((Integer)(demosHash.get(evt.getSource()))).intValue(),false);
        }
    }
    private void makeText(){
        Hashtable hs = new Hashtable();
        hs.put(new Integer('1'), " 1-\".,");//9
        hs.put(new Integer('2'), "абвг2");//2
        hs.put(new Integer('3'), "деёжз3");//3
        hs.put(new Integer('4'), "ийкл4");//4
        hs.put(new Integer('5'), "мноп5");//5
        hs.put(new Integer('6'), "рсту6");//6
        hs.put(new Integer('7'), "фхцч7");//7
        hs.put(new Integer('8'), "шщъы8");//8
        hs.put(new Integer('9'), "ьэюя9");//9
        hs.put(new Integer('#'), " ");


        TextField.addInputMode("абв", hs, false);

        hs = new Hashtable();
        hs.put(new Integer('1'), " 1-\".,");//9
        hs.put(new Integer('2'), "АБВГ2");//2
        hs.put(new Integer('3'), "ДЕЁЖЗ3");//3
        hs.put(new Integer('4'), "ИЙКЛ4");//4
        hs.put(new Integer('5'), "МНОП5");//5
        hs.put(new Integer('6'), "РСТУ6");//6
        hs.put(new Integer('7'), "ФХЦЧ7");//7
        hs.put(new Integer('8'), "ШЩЪЫ8");//8
        hs.put(new Integer('9'), "ЬЭЮЯ9");//9
        hs.put(new Integer('#'), " ");

        TextField.addInputMode("АБВ", hs, false);

        hs = new Hashtable();
        hs.put(new Integer('1'), "1+.");//9
        hs.put(new Integer('2'), "2-");//2
        hs.put(new Integer('3'), "3");//3
        hs.put(new Integer('4'), "4*");//4
        hs.put(new Integer('5'), "5/");//5
        hs.put(new Integer('6'), "6");//6
        hs.put(new Integer('7'), "7(");//7
        hs.put(new Integer('8'), "8)");//8
        hs.put(new Integer('9'), "9");//9
        hs.put(new Integer('0'), "0");//9
        hs.put(new Integer('#'), ".");//9

        TextField.addInputMode("1+2", hs, false);


        TextField.setDefaultChangeInputModeKey(new Integer('*').intValue());//42-* #-35 0-48 1-49 2-50
        TextField.setDefaultInputModeOrder(new String[] {"абв","АБВ","1+2","Abc","abc","ABC"});
        TextField.setClearText("Очистить");
    }
    public void cancelAlarm(){
        if (timer!=null){
            ticker.cancel();
            timer.cancel();
            mainScreen.removeComponent(lblTimer);
            user.setMessage("");
            user.setTimerTime(0);
            timer = null;
            lblTimer = null;
            ticker = null;
            sec_ticker = null;
        }
    }
    public void enableAlarm(boolean toBackGr){
        if (user.getTimerTime()>0){
            //проверяем не запущен ли таймер, если запущен, то останавливаем
            if (timer!=null){
                timer.cancel();
            }
            
            if (lblTimer==null){
                lblTimer = new Label();
                lblTimer.getStyle().setAlignment(Label.CENTER);
                mainScreen.addComponent(BorderLayout.CENTER,lblTimer);
            }

            timer = new Timer();
            
            AlarmTimerTask alarm = new AlarmTimerTask();
            long delay = user.getTimerTime() - System.currentTimeMillis();
            timer.schedule(alarm, delay<0?0:delay );//Запланировали включение таймера
            
            
            ticker = new Timer();
            sec_ticker = new SecondsTicker();
            ticker.scheduleAtFixedRate(sec_ticker, new Date(), 5000);
            //Каждые 5 секунды обновляем таймер на экране
            
            
            if (toBackGr){
                if(user.isBackGrSupported()) {
                    //Поддерживает сворачивание
                    Display.getInstance().minimizeApplication();
                }
                else{
                    //тут еще нужно проверить не разегистрировали ли таймер раньше
                    try{
                        PushRegistry.registerAlarm(getClass().getName(),
                            user.getTimerTime() );
                    }catch(Exception ex){}
                    finally{
                        saveDatas(shouldSaveBase,shouldSaveDiary,shouldSaveCoefUnits);
                        notifyDestroyed();
                        //Закрываем приложение, если удалось зарегистрировать таймер
                    }
                }
            }
        }
    }
    private class AlarmTimerTask extends TimerTask{
        public final void run()
        {
            String msg = user.getMessage();
            user.setMessage("");
            user.setTimerTime(0);
            ticker.cancel();
            mainScreen.removeComponent(lblTimer);
            timer = null;
            lblTimer = null;
            ticker = null;
            sec_ticker = null;
            //Все подготовили и сделали
            
            if (Display.getInstance().isMinimized())
                Display.getInstance().restoreMinimizedApplication();
            
            p = null;
            try 
            { 
                p = Manager.createPlayer(
                        getClass().getResourceAsStream("/alarm.mid"),
                        "audio/midi");
                p.start(); 
            }
            catch (IOException ioe) { } 
            catch (MediaException me) { }
            catch (Exception ex){ }
            
            Container c = new Container(new BorderLayout());
            TextArea txt = new TextArea(msg);
            txt.setEditable(false);
            c.addComponent(BorderLayout.CENTER,txt);
            Button btn = new Button("Выкл. звук");
            btn.getStyle().setAlignment(Button.CENTER);
            btn.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent ev){
                    Display.getInstance().callSerially(new Runnable() {
                        public void run() {
                            try{
                                if (p!=null) p.stop();
                            }
                            catch(MediaException me){}
                            catch (Exception ex){ }
                            finally{p=null;}
                        }
                    });
                }
            });
            c.addComponent(BorderLayout.SOUTH,btn);
            Dialog.show("Таймер", c, new Command[]{new Command("Ok")});

            try{
                if (p!=null) p.stop();
            }catch(MediaException me){}
            catch (Exception ex){ }
            finally{p=null;}
        }
    }
    private class SecondsTicker extends TimerTask{
        public final void run(){
            if (lblTimer!=null){
                long secLeft = (user.getTimerTime() - System.currentTimeMillis())/1000;
                int m = (int)secLeft / 60;
                int s = (int)secLeft % 60;
                lblTimer.setText("Осталось "+
                        Str.extendZero(m)+":"+
                        Str.extendZero(s)
                        );
            }
        }
    }
}
