/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */
package org.diacalc.mobile;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */

import com.sun.lwuit.*;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.layouts.BorderLayout;
import com.sun.lwuit.layouts.BoxLayout;
import com.sun.lwuit.list.DefaultListModel;
import com.sun.lwuit.plaf.Border;
import java.util.Vector;
import javax.microedition.midlet.MIDlet;
import org.diacalc.mobile.components.BackForm;
import org.diacalc.mobile.components.CloseListener;
import org.diacalc.mobile.components.NumbersKeyboard;
import org.diacalc.mobile.maths.Str;
import org.diacalc.mobile.maths.Sugar;
import org.diacalc.mobile.maths.User;

public class SettingsForm  extends FormBase implements ActionListener{
    private DCJmobile master;
    
    private ComboBox    round = new ComboBox(new DefaultListModel(
            new String[]{"до целой","до 0.5","до 0.25","до 0.1","до 0.05"}));

    private RadioButton rbPFC = new RadioButton(" Б-Ж-У");
    private RadioButton rbBE = new RadioButton(" ХЕ");
    private RadioButton rbCalor = new RadioButton(" Калории");
    private RadioButton rbDose = new RadioButton(" Доза");

    private CheckBox chBackGr = new CheckBox("поддерживается");

    private RadioButton rbMmol = new RadioButton("ммоль/л");
    private RadioButton rbMgDl = new RadioButton("мг/дл");
    private RadioButton rbWhole = new RadioButton("цельная");
    private RadioButton rbPlasma = new RadioButton("плазма");

    private CheckBox chTimeSense = new CheckBox("рассчитывать по времени");

    private final static int SUGAR_WIDTH = 80;
    private Vector timeLine = new Vector();
    private Vector timeCorr = new Vector();

    private ComboBox time = new ComboBox();
    private ComboBox timeDel = new ComboBox();

    private TextField fldTargetS,fldLowS,fldHiS;
    private NumbersKeyboard vk_numb;

    private int hour;
    
    private TextField fldLogin;
    private TextField fldPass;
    private TextField fldServer;
    
    private static final int HELP_COMMAND = 57;
    private static final Command helpCommand = new Command("Справка", HELP_COMMAND);
    
    
    private void storeSugars(){
        Sugar s = new Sugar();
        s.setSugar(Str.parseString(fldTargetS, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        master.getUser().setTargetSugar(s.getValue());
        s.setSugar(Str.parseString(fldLowS, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        master.getUser().setLowSugar(s.getValue());
        s.setSugar(Str.parseString(fldHiS, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        master.getUser().setHiSugar(s.getValue());
    }

    private ActionListener sugarStorer = new ActionListener(){
        public void actionPerformed(ActionEvent ev){
            storeSugars();
        }
    };
    private Container createSubPane(){
        Container c = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        c.getStyle().setBorder(Border.createLineBorder(1,0x646464));
        return c;
    }
    private Component createSugarsPane(){
        Container cBack = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        Container c = createSubPane();

        c.addComponent(new Label("Измерение СК"));
        ButtonGroup bgr = new ButtonGroup();
        bgr.add(rbWhole);
        bgr.add(rbPlasma);

        bgr = new ButtonGroup();
        bgr.add(rbMmol);
        bgr.add(rbMgDl);

        c.addComponent(rbWhole);
        c.addComponent(rbPlasma);
        c.addComponent(rbMmol);
        c.addComponent(rbMgDl);

        cBack.addComponent(c);
        c = createSubPane();

        fldTargetS = createSugarField(""+Str.round(new Sugar(master.getUser().getTargetSugar())
            .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
        fldLowS = createSugarField(""+Str.round(new Sugar(master.getUser().getLowSugar())
            .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
        fldHiS = createSugarField(""+Str.round(new Sugar(master.getUser().getHiSugar())
            .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));

        c.addComponent(Str.createPair("СКцель", fldTargetS,SUGAR_WIDTH));
        c.addComponent(Str.createPair("СКmin", fldLowS,SUGAR_WIDTH));
        c.addComponent(Str.createPair("СКmax", fldHiS,SUGAR_WIDTH));
        cBack.addComponent(c);

        cBack.getStyle().setPadding(2,2,5,5);
        cBack.setScrollableY(true);
        return cBack;
    }
    private TextField createSugarField(String value){
        TextField fld = new TextField();
        fld.setInputModeOrder(new String[]{"1+2"});
        fld.setInputMode("1+2");
        fld.setConstraint(TextField.DECIMAL);
        
        
        fld.setText(value);
        fld.addActionListener(sugarStorer);
        if (Display.getInstance().isTouchScreenDevice()){
            VirtualKeyboard.bindVirtualKeyboard(fld, vk_numb);
        }
        return fld;
    }
    public void execute(MIDlet m,boolean refresh){
        if (refresh){
            master = (DCJmobile)m;
            form.getContentPane().setLayout(new BorderLayout());

            vk_numb = new NumbersKeyboard();
            vk_numb.addCloseListener(new CloseListener(){
                public void wasClosed() {
                    Display.getInstance().callSerially(new Runnable() {
                        public void run() {
                            storeSugars();
                        }
                    });
                }
            });
               
            Tabs tp = new Tabs();

            tp.addTab("User",createInetPane() );
            
            tp.addTab("СК",createSugarsPane() );

            tp.addTab("Меню",createMenuPane() );

            tp.addTab("Время",createTimeCorrection() );

            tp.addTab("Настр. прог.",createProgramPane() );

            form.getContentPane().addComponent("Center",tp);
            //Setting values
            round.setSelectedIndex(master.getUser().getRound()-1);
            
            switch (master.getUser().getInfo()){
                case User.PFC_INFO: rbPFC.setSelected(true); break;
                case User.BE_INFO: rbBE.setSelected(true); break;
                case User.CALOR_INFO: rbCalor.setSelected(true); break;
                case User.DOSE_INFO: rbDose.setSelected(true); break;
            }
            chBackGr.setSelected(master.getUser().isBackGrSupported());
            rbPlasma.setSelected(master.getUser().isPlasma());
            rbWhole.setSelected(!master.getUser().isPlasma());
            rbMmol.setSelected(master.getUser().isMmol());
            rbMgDl.setSelected(!master.getUser().isMmol());
            chTimeSense.setSelected(master.getUser().isTimeSense());
            
            fldLogin.setText(master.getUser().getLogin());
            fldPass.setText(master.getUser().getPass());
            fldServer.setText(master.getUser().getServer());

            //добавляем слушателей
            round.addActionListener(this);
            rbPFC.addActionListener(this);
            rbBE.addActionListener(this);
            rbCalor.addActionListener(this);
            rbDose.addActionListener(this);
            chBackGr.addActionListener(this);
            rbWhole.addActionListener(this);
            rbPlasma.addActionListener(this);
            rbMmol.addActionListener(this);
            rbMgDl.addActionListener(this);
            chTimeSense.addActionListener(this);
            
            form.addMenuCommand(helpCommand, this);
        }

        initTimeLine();
    }
    private Component createMenuPane(){
        Container cBack = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        Container c = createSubPane();
        c.addComponent(new Label("Предел округления"));
        c.addComponent(round);
        cBack.addComponent(c);

        c = createSubPane();
        c.addComponent(new Label("Выводимая информация"));
        ButtonGroup bgr = new ButtonGroup();
        //bgr = new ButtonGroup();
        bgr.add(rbPFC);
        bgr.add(rbBE);
        bgr.add(rbCalor);
        bgr.add(rbDose);
        c.addComponent(rbPFC);
        c.addComponent(rbBE);
        c.addComponent(rbCalor);
        c.addComponent(rbDose);
        cBack.addComponent(c);

        c = createSubPane();
        c.addComponent(new Label("Коэффициенты"));
        c.addComponent(chTimeSense);
        cBack.addComponent(c);
        
        cBack.setScrollableY(true);
        return cBack;
    }
    private Component createProgramPane(){
        Container cBack = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        Container c = createSubPane();
        c.addComponent(new Label("Сворачивание"));
        c.addComponent(chBackGr);
        cBack.addComponent(c);
        
        cBack.setScrollableY(true);
        return cBack;
    }
    private ActionListener saveUser = new ActionListener(){
        public void actionPerformed(ActionEvent ev){
            saveUserInput();
        }
    };
    
    private void saveUserInput(){
        master.getUser().setLogin(fldLogin.getText());
        master.getUser().setPass(fldPass.getText());
        //Вот тут надо проверить сервер и заменить при необходимости
        if (fldServer.isEditable()){
            if (fldServer.getText().length()==0) fldServer.setText(User.DEFAULT_SERVER_PATH);
            else if (!fldServer.getText().endsWith("/")) fldServer.setText(fldServer.getText()+"/");
        }
        master.getUser().setServer(fldServer.getText());
    }
    private Component createInetPane(){
        Container cBack = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        Container c = createSubPane();
        
        Label lblLogin = new Label("login:");
        fldLogin = new TextField(master.getUser().getLogin());//"1+2","Abc","abc","ABC"
        fldLogin.setInputModeOrder(new String[]{"Abc","abc","ABC","123"});
        fldLogin.setInputMode("Abc");
        fldLogin.addActionListener(saveUser);
        fldLogin.setLabelForComponent(lblLogin);

        Label lblPass = new Label("password:");
        fldPass = new TextField(master.getUser().getPass());
        fldPass.setConstraint(TextField.PASSWORD);
        fldPass.setInputModeOrder(new String[]{"abc","ABC","123"});
        fldPass.setInputMode("abc");
        fldPass.addActionListener(saveUser);
        fldPass.setLabelForComponent(lblPass);

        Label lblServer = new Label("server:");
        fldServer = new TextField(User.DEFAULT_SERVER_PATH){
            public void longPointerPress(int x,int y){
                setEditable(true);
            }
        };
        fldServer.setConstraint(TextField.URL);
        fldServer.setInputModeOrder(new String[]{"abc","ABC","123"});
        fldServer.setInputMode("abc");
        fldServer.addActionListener(saveUser);
        fldServer.setLabelForComponent(lblServer);
        fldServer.setEditable(false);
        
        c.addComponent(lblLogin);
        c.addComponent(fldLogin);
        
        c.addComponent(lblPass);
        c.addComponent(fldPass);
        
        c.addComponent(lblServer);
        c.addComponent(fldServer);
        cBack.addComponent(c);
        
        VirtualKeyboard vk = new VirtualKeyboard();
        vk.setInputModeOrder(new String[]{VirtualKeyboard.QWERTY_MODE,VirtualKeyboard.NUMBERS_SYMBOLS_MODE});
        VirtualKeyboard.bindVirtualKeyboard(fldPass, vk);
        VirtualKeyboard.bindVirtualKeyboard(fldLogin, vk);
        VirtualKeyboard.bindVirtualKeyboard(fldServer, vk);

        vk.addCommandListener(new ActionListener(){
            public void actionPerformed(ActionEvent ev){
                if (ev.getCommand().getCommandName().equals("Ok")){
                    Display.getInstance().callSerially(new Runnable(){
                        public void run(){
                            saveUserInput();
                        }
                    });
                }
            }
        });
        
        cBack.setScrollableY(true);
        return cBack;
    }
    private ActionListener timeSelection = new ActionListener(){
        public void actionPerformed(ActionEvent ev){
            if (ev.getSource()==time){
                master.getUser().setTimeCorr( time.getSelectedIndex() - hour );
                if (master.getUser().isTimeSense()){
                    master.calcCoefsbyTime();
                    master.shouldRefreshMenu();
                }
            }else{
                master.getUser().setTimeDiary( timeDel.getSelectedIndex() -12 );
            }
        }
    };

    private Component createTimeCorrection(){
        Container cBack = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        Container c = createSubPane();

        c.addComponent(new Label("Текущее время"));
        time.setModel(new DefaultListModel(timeLine));
        c.addComponent(time);

        cBack.addComponent(c);

        c = createSubPane();
        c.addComponent(new Label("Коррекция при экспорте"));
        timeDel.setModel(new DefaultListModel(timeCorr));
        c.addComponent(timeDel);

        cBack.addComponent(c);
        
        time.addActionListener(timeSelection);
        timeDel.addActionListener(timeSelection);
        
        cBack.setScrollableY(true);
        return cBack;
    }
    private void initTimeLine(){
        while (time.size()>0)       time.getModel().removeItem(0);
        while (timeDel.size()>0)    timeDel.getModel().removeItem(0);

        java.util.Calendar cal = java.util.Calendar.getInstance();
        hour = cal.get(java.util.Calendar.HOUR_OF_DAY);
        for(int i=0;i<24;i++){
            time.addItem(Str.extendZero(i)+":"+
                    Str.extendZero(cal.get(java.util.Calendar.MINUTE)));
            timeDel.addItem(
                    (((i-12)>=0)?("+"+(i-12)):(""+(i-12))) );
        }
        time.setSelectedIndex(hour + master.getUser().getTimeCorr() );
        timeDel.setSelectedIndex(12 + master.getUser().getTimeDiary() );
    }
    public void actionPerformed(ActionEvent ev){
        if (ev.getCommand()!=null && ev.getCommand().getId()==HELP_COMMAND){
            BackForm helpForm = new BackForm("Справка",
                        new Command("Назад"){
                            public void actionPerformed(ActionEvent ae){
                                SettingsForm.this.form.show();
                            }
                        });
            helpForm.setScrollableY(true);
            helpForm.setLayout(new BorderLayout());
            TextArea helpText = new TextArea(getHelp(), 5, 10);
            helpText.setEditable(false);
            helpForm.addComponent(BorderLayout.CENTER, helpText);
            helpForm.show();
        }else if (ev.getSource()==round){
            master.getUser().setRound(round.getSelectedIndex()>=0?(round.getSelectedIndex()+1):1);
        }else if (ev.getSource()==rbPFC){
            master.getUser().setInfo(User.PFC_INFO);
            master.shouldRefreshMenu();
        }else if (ev.getSource()==rbBE){
            master.getUser().setInfo(User.BE_INFO);
            master.shouldRefreshMenu();
        }else if (ev.getSource()==rbCalor){
            master.getUser().setInfo(User.CALOR_INFO);
            master.shouldRefreshMenu();
        }else if (ev.getSource()==rbDose){
            master.getUser().setInfo(User.DOSE_INFO);
            master.shouldRefreshMenu();
        }
        else if (ev.getSource()==chBackGr){
            master.getUser().setBackGrSupported(chBackGr.isSelected());
        }
        else if (ev.getSource()==rbWhole || ev.getSource()==rbPlasma){
            master.getUser().setPlasma(rbPlasma.isSelected());
            master.shouldRefreshMenu();
            refreshSugars();
        }
        else if (ev.getSource()==rbMmol || ev.getSource()==rbMgDl){
            master.getUser().setMmol(rbMmol.isSelected());
            master.shouldRefreshMenu();
            refreshSugars();
        }
        else if (ev.getSource()==chTimeSense){
            master.getUser().setTimeSense(chTimeSense.isSelected());
            if (master.getUser().isTimeSense()){
                master.calcCoefsbyTime();
                master.shouldRefreshMenu();
            }
        }
    }
    private void refreshSugars(){
        fldTargetS.setText(""+Str.round(new Sugar(master.getUser().getTargetSugar())
                .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
        fldLowS.setText(""+Str.round(new Sugar(master.getUser().getLowSugar())
                .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
        fldHiS.setText(""+Str.round(new Sugar(master.getUser().getHiSugar())
                .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
    }
    public String getName(){
        return "Настройки";
    }
    public String getIconName(){
        return "settings";
    }
    protected String getHelp() {
        return "В этом окне можно изменить различные настройки.\n" +
                "1. До какой величины будет округляться доза в меню.\n" +
                "2. Информация, которая будет выводится в меню напротив введенного веса. " +
                "(Если выбрать дозу, то вверху в результатах расчета будут выводиться калории)\n" +
                "3. Поддерживает ли телефон сворачивание приложений (программа " +
                "никак это не проверяет, поэтому вам нужно определить отмечать " +
                "или нет эту функцию самостоятельно).\n" +
                "4. Если используется дневник и он выгружается на сервер, то следует " +
                "установить систему измерения сахара крови, что бы в DiaCalcJ получать верные " +
                "значения СК.\n"+
                "5. Если отметить чувствительность ко времени, то программа будет расчитывать "
                + "коэффициенты для меню на основе данных в окне \"Коэффициенты\"";
    }

}
