/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */

package org.diacalc.mobile.components;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */
import org.diacalc.mobile.maths.Str;

public class TimeValidator implements MaskValidator{
    private final static String numb = "1234567890";
    public Object parse(MaskTextField fld){
        String s = fld.getText();
        //Удаляем все "левые" символы
        String st1="";
        //удаляем все неиспользуемые символы
        for(int i=0;i<s.length();i++){
            for(int j=0;j<numb.length();j++){
                if (s.charAt(i)==numb.charAt(j)){
                    st1 += s.charAt(i);
                    break;
                }
            }
        }
        s = st1;
        
        if (s.length()==3) s = "0"+s;
        if (s.length()<4) return new Integer(8*60*60);//Недостаточно символов
        if (s.length()>4) s = s.substring(0, 4);
        String hours = s.substring(0, 2);
        String min = s.substring(2);
        
        //Предполагаем, что могут быть только положительные цифры
        int h = Integer.parseInt(hours);
        int m = Integer.parseInt(min);
        
        if (h>23){
            h = 23;
            fld.setText( "" +h + fld.getText().substring(3) );
        }
        if (m>59){
            m = 59;
            fld.setText( fld.getText().substring(0,3)+m );
        }
        
        return new Integer( m*60 + h * 60 * 60);
    }
    public String getStringValue(MaskTextField fld,Object o){
        int h = ((Integer)o).intValue() / (60*60);
        int m = ((Integer)o).intValue() % (60*60) / 60;
        
        return Str.extendZero(h) + ":" +  Str.extendZero(m);
    }
}
