/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */

package org.diacalc.mobile.maths;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */
import java.io.*;
import java.util.Hashtable;
import java.util.Vector;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import org.diacalc.mobile.DCJmobile;
import org.diacalc.mobile.products.ProductGroup;
import org.diacalc.mobile.products.ProductInBase;
import org.diacalc.mobile.products.ProductInMenu;


public class DoingPOST{
    private static boolean versionChecked = false;
    private String answer = "";
    private String errorMsg = "";
    private boolean error = false;
    
    private final static String SCRIPT_NAME = "server.php";
    
    public final static String ERROR = "error";
    public final static String NO_ERROR = "IT'S OK";
	
    public final static String MENU_MENU  = "menu content";
    public final static String MENU_USER = "menu user";

    public final static String PRODS_GROUP = "group content";
    public final static String PRODS_PRODS = "products content";


    private final static String ACT_GET_MENU = "get menu";
    private final static String ACT_SEND_MENU = "send menu";

    private final static String ACT_GET_PRODS = "get mobile base";
    private final static String ACT_SEND_PRODS = "send m_base";
    
    private final static String ACT_SEND_DIARY = "send m_diary";
    
    private final static String ACT_CHECK_VERSION = "check version";
    private final static String PROG_NAME = "DCJM_TOUCH";
    public  final static String VERSION_MESSAGE = "version message";
    private User user;

    public DoingPOST(User user){
        this.user = user;
    }
    private void doPost(String query){
        HttpConnection httpConn = null;
        InputStream is = null;
        OutputStreamWriter out = null;
        OutputStream os = null;

        try {
            // Open an HTTP Connection object
            httpConn = (HttpConnection)Connector.open(user.getServer()+SCRIPT_NAME,Connector.READ_WRITE);
            // Setup HTTP Request to POST
            httpConn.setRequestMethod(HttpConnection.POST);
            httpConn.setRequestProperty("User-Agent",
                "Profile/" + System.getProperty("microedition.configuration") +
                " Configuration/" + System.getProperty("microedition.profiles"));
            httpConn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");

            String locale = System.getProperty("microedition.locale");
            if (locale != null) {
                httpConn.setRequestProperty("Content-Language", locale);
            }
            httpConn.setRequestProperty("Content-Length", ""+query.getBytes().length );

            // --- write ---
            os = httpConn.openOutputStream();
            //out = new OutputStreamWriter(httpConn.openOutputStream(),"UTF-8");
            
            os.write(query.getBytes());
            //out.write(params);
            
            if (httpConn.getResponseCode()==HttpConnection.HTTP_OK){
                int length = (int)httpConn.getLength();
                is = httpConn.openInputStream();

                if (length==-1){//don't know the length
                    int chr;
                    ByteArrayOutputStream bout = new ByteArrayOutputStream();

                    while ((chr = is.read()) != -1)
                        bout.write(chr);

                    if (bout!=null){
                        answer = new String(bout.toByteArray(),"UTF-8");
                        bout.close();
                    }
                }
                else{//known length
                    DataInputStream dis = new DataInputStream(is);
                    byte[] data = new byte[length];
                    //try to read all the bytes returned from the server.
                    dis.readFully(data);
                    answer = new String(data,"UTF-8");
                    dis.close();
                }
                if (!answer.endsWith("<ok>")){
                    error = true;
                    errorMsg = answer;
                }
            }
            else{
                errorMsg += "Server returned unhandled " +
                "response code. "+httpConn.getResponseCode();
                error = true;
            }
        }catch (Throwable t){
            errorMsg += "Exception while connecting to the internet:"+t.getMessage();
            error = true;
        }
        //Since only limited number of network objects can be in open state
        //it is necessary to clean them up as soon as we are done with them.
        finally {//httpConn out is
            if (is!=null)
                try{
                    is.close();
                }catch(Throwable t){
                    errorMsg += "Exception while close IS:"+t.getMessage();
                    error = true;
                }
            if(os != null)
                try{
                    os.close();
                }catch(Throwable t){
                    errorMsg += "Exeption while close OS:"+t.getMessage();
                    error = true;
                }
            if(httpConn != null)
                try{
                    httpConn.close();
                }catch(Throwable t){
                    errorMsg += "Exception while close HTTPCONN:"+t.getMessage();
                    error = true;
                }
        }
    }
    public Hashtable checkVersion(){
        if (versionChecked){
            return null;//Уже проверяли, возвращаем пустое значение
        }
        Hashtable res = new Hashtable();
        versionChecked = true;
        //Начинаем проверку
        String query = addKeyValue("", "login", user.getLogin());
        query = addKeyValue(query, "pass", user.getPass());
        query = addKeyValue(query, "action", ACT_CHECK_VERSION);
        query = addKeyValue(query,"pName",PROG_NAME);
        query = addKeyValue(query,"pVer",""+DCJmobile.PROGRAM_VERSION);
        query = addKeyValue(query,"ok","ok");
        
        doPost(query);
        
        if (error){
            res.put(ERROR, errorMsg);
        }else{
            if (answer.equals("<ok>")) return null;
            res.put(ERROR, NO_ERROR);
            res.put(VERSION_MESSAGE,Str.replace( answer, "<ok>", "") );
        }
        
        return res;
    }
    
    public Hashtable sendProducts(Vector gr,Vector prs){
        String query = addKeyValue("", "login", user.getLogin());
        query = addKeyValue(query, "pass", user.getPass());
        query = addKeyValue(query, "action", ACT_SEND_PRODS);
        
        for(int i=0;i<gr.size();i++){
            query = addKeyValue(query,"grids[]",""+((ProductGroup)gr.elementAt(i)).getId());
            query = addKeyValue(query,"grnames[]",((ProductGroup)gr.elementAt(i)).getName());
        }
        
        //теперь посылаем продукты из этой группы
        for(int p=0;p<prs.size();p++){
            ProductInBase pr = (ProductInBase)prs.elementAt(p);
                query = addKeyValue(query,"prowners[]",
                        ""+pr.getOwner());
                query = addKeyValue(query,"prnames[]",
                        pr.getName());
                query = addKeyValue(query,"prprots[]",""+
                        pr.getProt());
                query = addKeyValue(query,"prfats[]",""+
                        pr.getFat());
                query = addKeyValue(query,"prcarbs[]",""+
                        pr.getCarb());
                query = addKeyValue(query,"prgis[]",""+
                        pr.getGi());
                query = addKeyValue(query,"prweights[]",""+
                        pr.getWeight());
                query = addKeyValue(query,"prusages[]",""+
                        pr.getUsage());
        }
        query = addKeyValue(query,"ok","ok");
        
        doPost(query);
        
        Hashtable res = new Hashtable();
        
        if (error){
            res.put(ERROR, errorMsg);
        }else{
            res.put(ERROR, NO_ERROR);
        }
        return res;
    }
    public Hashtable receiveProducts(){
        String query = addKeyValue("", "login", user.getLogin());
        query = addKeyValue(query, "pass", user.getPass());
        query = addKeyValue(query, "action", ACT_GET_PRODS);
        query = addKeyValue(query, "ok", "ok");
        
        doPost(query);
        
        Hashtable res = new Hashtable();
        
        if (error){
            res.put(ERROR, errorMsg);
            return res;
        }
        
        String groups = null;
        try{
            groups = getTaggedText(answer, "groups");
        }catch(Exception ex){
            res.put(ERROR, ex.getMessage());
            return res;
        }

        String prods = null;
        try{
            prods = getTaggedText(answer, "prods");
        }catch(Exception ex){
            res.put(ERROR, ex.getMessage());
            return res;
        }

        res.put(PRODS_GROUP, parseGroups(groups) );
        res.put(PRODS_PRODS, parseProducts(prods) );
        res.put(ERROR, NO_ERROR);
        
        return res;
    }
    private Vector parseGroups(String groups){
        Vector arr = new Vector();
        Vector lines = Str.split(groups.trim(),"<br>");
        for(int i=0;i<lines.size();i++){
          if (((String)lines.elementAt(i)).trim().length()>0){
            Vector param = Str.split( ((String)lines.elementAt(i)).trim(),
                    " ");
            int id;
            if (param.size()>1){
                try{
                    id = Integer.parseInt((String)param.elementAt(param.size()-1));
                }catch(Exception ex){
                    //ex.printStackTrace();
                    id = 0;
                }
                String name ="";
                for(int j=0;j<(param.size()-1);j++){
                    name += (String)param.elementAt(j) + " ";
                }
                name = name.trim();
                arr.addElement(new ProductGroup(name,id));
            }
          }
        }
        return arr;
    }
    
    private Vector parseProducts(String prods){
        Vector arr = new Vector();
        Vector lines = Str.split(prods.trim(),"<br>");
        for(int i=0;i<lines.size();i++){
          if (((String)lines.elementAt(i)).trim().length()>0){
            Vector param = Str.split( ((String)lines.elementAt(i)).trim(),
                    " ");
            int gi,owner,usage;
            float c,f,p;
            if (param.size()>6){
                try{
                    owner = Integer.parseInt((String)param.elementAt(param.size()-1));
                    usage = Integer.parseInt((String)param.elementAt(param.size()-2));
                    gi = Integer.parseInt((String)param.elementAt(param.size()-3));
                    c = Float.parseFloat(
                    ((String)param.elementAt(param.size()-4)) );
                    f = Float.parseFloat(
                    ((String)param.elementAt(param.size()-5)) );
                    p = Float.parseFloat(
                    ((String)param.elementAt(param.size()-6)) );
                }catch(Exception ex){
                    //ex.printStackTrace();
                    owner = usage = gi = 0;
                    c = f = p = 0f;
                }
                String name ="";
                for(int j=0;j<(param.size()-6);j++){
                    name += (String)param.elementAt(j) + " ";
                }
                name = name.trim();
                arr.addElement(new ProductInBase(name,p,f,c,gi,100f,false,owner,usage));
            }
          }
        }
        return arr;
    }
    public Hashtable receiveMenu(){
        String query = addKeyValue("", "login", user.getLogin());
        query = addKeyValue(query, "pass", user.getPass());
        query = addKeyValue(query, "action", ACT_GET_MENU);
        query = addKeyValue(query, "ok", "ok");
        
        doPost(query);
        
        Hashtable res = new Hashtable();
        
        if (error){
            res.put(ERROR, errorMsg);
            return res;
        }
        
        String menu = null;
        try{
            menu = getTaggedText(answer, "menu");
        }catch(Exception ex){
            res.put(ERROR, ex.getMessage());
            return res;
        }
        
        String coefs = null;
        try{
            coefs = getTaggedText(answer, "coefs");
        }catch(Exception ex){
            res.put(ERROR, ex.getMessage());
            return res;
        }
        
        
        res.put(MENU_MENU, parseMenu( menu ) );
        res.put(MENU_USER, parseCoefs( coefs ) );
        res.put(ERROR, NO_ERROR);
        
        return res;
    }
    public Hashtable sendMenu(Vector prods){
        Hashtable res = new Hashtable();
        if (prods.isEmpty()){
            res.put(ERROR, "Нечего экспортировать");
            return res;
        }
        
        String query = addKeyValue("", "login", user.getLogin());
        query = addKeyValue(query, "pass", user.getPass());
        query = addKeyValue(query, "action", ACT_SEND_MENU);
        
        query = addKeyValue(query, "k1", ""+user.getFactors().getK1Value()*10/user.getFactors().getBEValue() );
        query = addKeyValue(query, "k2", ""+user.getFactors().getK2() );
        query = addKeyValue(query, "k3", ""+user.getFactors().getK3() );
        query = addKeyValue(query, "sh1", ""+user.getS1() );
        query = addKeyValue(query, "sh2", ""+user.getS2() );
        
        for(int i=0;i<prods.size();i++){
            ProductInMenu pr = (ProductInMenu)prods.elementAt(i);
            query = addKeyValue(query, "names[]",pr.getName() );
            query = addKeyValue(query, "prots[]",""+pr.getProt() );
            query = addKeyValue(query, "fats[]",""+pr.getFat() );
            query = addKeyValue(query, "carbs[]",""+pr.getCarb() );
            query = addKeyValue(query, "gis[]",""+pr.getGi() );
            query = addKeyValue(query, "weights[]",""+pr.getWeight() );
            query = addKeyValue(query, "issnacks[]","0" );
        }
        
        query = addKeyValue(query, "ok", "ok");
        
        doPost(query);
        
        if (error){
            res.put(ERROR, errorMsg);
        }else{
            res.put(ERROR, NO_ERROR);
        }
        return res;
    }
    public Hashtable sendDiarySugars(Vector sugars,DCJmobile master){
        String query = addKeyValue("", "login", user.getLogin());
        query = addKeyValue(query, "pass", user.getPass());
        query = addKeyValue(query, "action", ACT_SEND_DIARY);
        
        //Записи о сахарах
        for(int i=0;i<sugars.size();i++){
            DiaryUnit du = (DiaryUnit)sugars.elementAt(i);
            query = addKeyValue(query,"duStime[]",""+
                    (du.getTime()+master.getUser().getTimeDiary()*1000*60*60));
            query = addKeyValue(query,"duSsugar[]",""+du.getSh1());
            query = addKeyValue(query,"duScomm[]",""+du.getComment());
        }
        query = addKeyValue(query,"ok","ok");
        
        doPost(query);
        
        Hashtable res = new Hashtable();
        if (error){
            res.put(ERROR, errorMsg);
        }else{
            res.put(ERROR, NO_ERROR);
        }
        return res;
    }
    public Hashtable sendDiaryComments(Vector comments, DCJmobile master){
        String query = addKeyValue("", "login", user.getLogin());
        query = addKeyValue(query, "pass", user.getPass());
        query = addKeyValue(query, "action", ACT_SEND_DIARY);
        
        //Комментарии
        for(int i=0;i<comments.size();i++){
            DiaryUnit du = (DiaryUnit)comments.elementAt(i);
            query = addKeyValue(query,"duCtime[]",""+
                    (du.getTime()+master.getUser().getTimeDiary()*1000*60*60));
            query = addKeyValue(query,"duCcomm[]",""+du.getComment());
        }
        query = addKeyValue(query,"ok","ok");
       
        doPost(query);
       
        Hashtable res = new Hashtable();
        if (error){
            res.put(ERROR, errorMsg);
        }else{
            res.put(ERROR, NO_ERROR);
        }
        return res;
    }
    public Hashtable sendDiaryMenus(Vector menus, DCJmobile master){
        String pre_query = addKeyValue("", "login", user.getLogin());
        pre_query = addKeyValue(pre_query, "pass", user.getPass());
        pre_query = addKeyValue(pre_query, "action", ACT_SEND_DIARY);
        
        String query;
        Hashtable res = new Hashtable();
        //Начинаем сложные записи
        for(int i=0;i<menus.size();i++){
            query = pre_query;
            DiaryUnit du = (DiaryUnit)menus.elementAt(i);

            query = addKeyValue(query,"duMid[]",""+du.getId());
            query = addKeyValue(query,"duMtime[]",""+
                    (du.getTime()+master.getUser().getTimeDiary()*1000*60*60));
            query = addKeyValue(query,"duMcomm[]",du.getComment().length()==0?"Комментарий":du.getComment());
            query = addKeyValue(query,"duMsh1[]",""+du.getSh1());
            query = addKeyValue(query,"duMsh2[]",""+du.getSh2());
            query = addKeyValue(query,"duMk1[]",""+du.getFactors().getK1Value()*10/master.getUser().getFactors().getBEValue()); //us.getFactors().getK1Value()*10/us.getFactors().getBEValue()
            query = addKeyValue(query,"duMk2[]",""+du.getFactors().getK2());
            query = addKeyValue(query,"duMk3[]",""+du.getFactors().getK3());
            query = addKeyValue(query,"duMdose[]",""+du.getDose());
            query = addKeyValue(query,"duMprot[]",""+du.getProduct().getProt());
            query = addKeyValue(query,"duMfat[]",""+du.getProduct().getFat());
            query = addKeyValue(query,"duMcarb[]",""+du.getProduct().getCarb());
            query = addKeyValue(query,"duMgi[]",""+du.getProduct().getGi());
            query = addKeyValue(query,"duMweight[]",""+du.getProduct().getWeight());

            //Продукты
            for(int p=0;p<master.getDiaryRecs().size();p++){
                ProductInMenu pr = (ProductInMenu)master.getDiaryRecs().elementAt(p);
                if (du.getId()==pr.getOwner()){

                    query = addKeyValue(query,"drowner[]",""+pr.getOwner());
                    query = addKeyValue(query,"drname[]",pr.getName());
                    query = addKeyValue(query,"drprot[]",""+pr.getProt());
                    query = addKeyValue(query,"drfat[]",""+pr.getFat());
                    query = addKeyValue(query,"drcarb[]",""+pr.getCarb());
                    query = addKeyValue(query,"drgi[]",""+pr.getGi());
                    query = addKeyValue(query,"drweight[]",""+pr.getWeight());
                }
            }
            query = addKeyValue(query,"ok","ok");
            
            doPost(query);
            
            if (error){
                res.put(ERROR, errorMsg);
                //Произошла ошибка, далее продолжать смысла нет
                break;
            }
        }
        if (!error){
            res.put(ERROR, NO_ERROR);
        }
        
        return res;
    }
    private String addKeyValue(String query, String key, String value){
        String res;
        if (query==null){
            res = "";
        }
        else res = query;
        if (res.length()>0){
            res += "&";
        }
        //if (value.length()==0) value = "===";
        res += key + "=" + URLencode(value);

        return res;
    }
    private Vector parseMenu(String st){
        Vector arr = new Vector();
        Vector lines = Str.split(st.trim(),"<br>");
        for(int i=0;i<lines.size();i++){
          if (((String)lines.elementAt(i)).trim().length()>0){
            Vector param = Str.split( ((String)lines.elementAt(i)).trim(),
                    " ");
            int gi;
            float w,p,c,f;
            boolean snack = false;
            if (param.size()>1){
                try{
                    snack = 
                            Integer.parseInt((String)param.elementAt(param.size()-1))!=0;
                    w = Float.parseFloat(
                        ((String)param.elementAt(param.size()-2)) );
                    gi = Integer.parseInt((String)param.elementAt(param.size()-3));
                    c = Float.parseFloat(
                        ((String)param.elementAt(param.size()-4)) );
                    f = Float.parseFloat(
                        ((String)param.elementAt(param.size()-5)) );
                    p = Float.parseFloat(
                        ((String)param.elementAt(param.size()-6)));
                }catch(Exception ex){
                    gi = 0;
                    w = p = f = c = 0f;
                }
                String name ="";
                for(int j=0;j<(param.size()-6);j++){
                    name += (String)param.elementAt(j) + " ";
                }
                name = name.trim();
                arr.addElement(new ProductInMenu(name,p,f,c,gi,w, snack?-11:-1 ));
            }
          }
        }
        return arr;
    }
    private User parseCoefs(String st){
        Vector lines = Str.split(st.trim(),"<br>");
        for(int i=lines.size();i>0;i--){
            if ( ((String)lines.elementAt(i-1)).trim().length()==0 ){
                lines.removeElementAt(i-1);
            }
        }
        User user = new User();
        if (lines.size()==1){
            Vector vl = Str.split( (String)lines.elementAt(0), " ");
            if (vl.size()==5){
                try{
                    float k1 = Float.parseFloat((String)vl.elementAt(0)) *
                            user.getFactors().getBE(Factors.DIRECT) / 10f;
                    user.getFactors().setK1Value(k1);
                    user.getFactors().setK2( Float.parseFloat((String)vl.elementAt(1)) );
                    user.getFactors().setK3( Float.parseFloat((String)vl.elementAt(2)) );

                    user.setS1(Float.parseFloat((String)vl.elementAt(3)));
                    user.setS2(Float.parseFloat((String)vl.elementAt(4)));
                }catch(Exception ex){}
            }
        }

        return user;
    }
    
    public static String getTaggedText(String output, String tag) throws Exception{
        Vector strs = new Vector();
        String tagfullst = "<"+tag+">";
        String tagfullend = "</"+tag+">";
        int st = 0;
        int end = 0;
        st = output.indexOf(tagfullst);
        if (st<0) throw new Exception("starting tag "+tag+" not found");
        
        end = output.indexOf( tagfullend, st+tagfullst.length());
        if (end<0) throw new Exception("ending tag "+tag+" not found");
        
        return output.substring(st+tagfullst.length(), end);
    }
    
    public static String URLencode(String s){
        StringBuffer sbuf = new StringBuffer();
        int len = s.length();
        for (int i = 0; i < len; i++) {
          int ch = s.charAt(i);
          if ('A' <= ch && ch <= 'Z') {		// 'A'..'Z'
            sbuf.append((char)ch);
          } else if ('a' <= ch && ch <= 'z') {	// 'a'..'z'
            sbuf.append((char)ch);
          } else if ('0' <= ch && ch <= '9') {	// '0'..'9'
            sbuf.append((char)ch);
          } else if (ch == ' ') {			// space
            sbuf.append('+');
          } else if (ch <= 0x007f) {		// other ASCII
            sbuf.append(hex[ch]);
          } else if (ch <= 0x07FF) {		// non-ASCII <= 0x7FF
            sbuf.append(hex[0xc0 | (ch >> 6)]);
            sbuf.append(hex[0x80 | (ch & 0x3F)]);
          } else {					// 0x7FF < ch <= 0xFFFF
            sbuf.append(hex[0xe0 | (ch >> 12)]);
            sbuf.append(hex[0x80 | ((ch >> 6) & 0x3F)]);
            sbuf.append(hex[0x80 | (ch & 0x3F)]);
          }
        }
        return sbuf.toString();
   }
   final static String[] hex = {
    "%00", "%01", "%02", "%03", "%04", "%05", "%06", "%07",
    "%08", "%09", "%0a", "%0b", "%0c", "%0d", "%0e", "%0f",
    "%10", "%11", "%12", "%13", "%14", "%15", "%16", "%17",
    "%18", "%19", "%1a", "%1b", "%1c", "%1d", "%1e", "%1f",
    "%20", "%21", "%22", "%23", "%24", "%25", "%26", "%27",
    "%28", "%29", "%2a", "%2b", "%2c", "%2d", "%2e", "%2f",
    "%30", "%31", "%32", "%33", "%34", "%35", "%36", "%37",
    "%38", "%39", "%3a", "%3b", "%3c", "%3d", "%3e", "%3f",
    "%40", "%41", "%42", "%43", "%44", "%45", "%46", "%47",
    "%48", "%49", "%4a", "%4b", "%4c", "%4d", "%4e", "%4f",
    "%50", "%51", "%52", "%53", "%54", "%55", "%56", "%57",
    "%58", "%59", "%5a", "%5b", "%5c", "%5d", "%5e", "%5f",
    "%60", "%61", "%62", "%63", "%64", "%65", "%66", "%67",
    "%68", "%69", "%6a", "%6b", "%6c", "%6d", "%6e", "%6f",
    "%70", "%71", "%72", "%73", "%74", "%75", "%76", "%77",
    "%78", "%79", "%7a", "%7b", "%7c", "%7d", "%7e", "%7f",
    "%80", "%81", "%82", "%83", "%84", "%85", "%86", "%87",
    "%88", "%89", "%8a", "%8b", "%8c", "%8d", "%8e", "%8f",
    "%90", "%91", "%92", "%93", "%94", "%95", "%96", "%97",
    "%98", "%99", "%9a", "%9b", "%9c", "%9d", "%9e", "%9f",
    "%a0", "%a1", "%a2", "%a3", "%a4", "%a5", "%a6", "%a7",
    "%a8", "%a9", "%aa", "%ab", "%ac", "%ad", "%ae", "%af",
    "%b0", "%b1", "%b2", "%b3", "%b4", "%b5", "%b6", "%b7",
    "%b8", "%b9", "%ba", "%bb", "%bc", "%bd", "%be", "%bf",
    "%c0", "%c1", "%c2", "%c3", "%c4", "%c5", "%c6", "%c7",
    "%c8", "%c9", "%ca", "%cb", "%cc", "%cd", "%ce", "%cf",
    "%d0", "%d1", "%d2", "%d3", "%d4", "%d5", "%d6", "%d7",
    "%d8", "%d9", "%da", "%db", "%dc", "%dd", "%de", "%df",
    "%e0", "%e1", "%e2", "%e3", "%e4", "%e5", "%e6", "%e7",
    "%e8", "%e9", "%ea", "%eb", "%ec", "%ed", "%ee", "%ef",
    "%f0", "%f1", "%f2", "%f3", "%f4", "%f5", "%f6", "%f7",
    "%f8", "%f9", "%fa", "%fb", "%fc", "%fd", "%fe", "%ff"
   };
    
}